config/routes.rb
Rails.application.routes.draw do

  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  devise_for :users

  root 'static_pages#home'

  resources :line_items do
    match :qty, action: :qty, via: [:post, :delete], on: :member #-> url.com/line_items/qty
    match :input_field_change, action: :input_field_change, via: :post, on: :member
  end
  resources :carts do
    match :empty_line_items, action: :empty_line_items, via: :delete, on: :member #-> url.com/line_items/qty
  end

  get 'navbar_cart'           => 'carts#navbar_cart'
  get 'continue_shopping'     => 'carts#continue_shopping'
  get 'search'                => 'products#product_search'
  get 'checkout'              => 'charges#checkout'
  get 'support'               => 'support_messages#new'

  resources :carts, :orders
  resources :charges
  resources :categories, only: [:show, :index]
  resources :departments, only: [:index]
  resources :products, only: [:show, :index, :new, :create]
  resources :static_pages, only: [:home, :help]
  resources :support_messages, only: [:create]

   

end

app/models/product.rb
class Product < ActiveRecord::Base
	belongs_to :category, dependent: :destroy, counter_cache: true
	has_one :department, through: :category
	has_many :line_items
	has_many :orders, through: :line_items
	has_many :attachments, dependent: :destroy
	has_many :product_attributes
	accepts_nested_attributes_for :attachments, allow_destroy: true
	accepts_nested_attributes_for :product_attributes, allow_destroy: true
	before_destroy :ensure_not_referenced_by_any_line_item

	def self.search(search, selected)
		if selected.present?
	  	where("category_id = :selected AND title ILIKE :search", selected: selected, search: "%#{search}%" )
		else
			where("title ILIKE :search", search: "%#{search}%" )
		end
	end

	def discount_percent(original_price, discount_price)
		(discount_price / original_price) * 100
	end

	def price_with_discount(original_price, discount_price)
		if discount_price.present?
			original_price - discount_price 
		else
			original_price
		end
	end

	private
 		#ensure that there are no line items referencing this product
		def ensure_not_referenced_by_any_line_item
		 	if line_items.empty?
		 		return true
		 	else
		 		errors.add(:base, 'Line Items present')
		 		return false
			end
		end

end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  include CurrentCart
  before_action :set_cart, only: [:show, :index, :product_search]

	def show
    #if current_user
  	@product = Product.find(params[:id])
    #@department = Department.find(@product.department_id)
	end

  def index
    if !params[:search].blank? 
      #Category based search
      @products = Product.search(params[:search], params[:selected]).includes(:attachments).paginate(page: params[:page], :per_page => 30)
    else
      #List all products based on category
      @products = Product.where("category_id = ?", params[:selected]).paginate(page: params[:page])
    end
    @current_category = Category.find(params[:selected]).name
  end

  def product_search 
    #Global search
    @products = Product.search(params[:search], params[:selected]).order("created_at DESC").paginate(page: params[:page], :per_page => 30) if params[:search].present?
    @categories = Category.all
  end

end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/products/_product.html.erb
<div class="col-sm-6 col-lg-3 col-xs-12 col-md-4 thumb">
  <div class="thumb-info">
    <%= link_to product do %>
      <%= cl_image_tag product.attachments.first.image, :width=>250, :height=>250, :crop=>"pad" if product.attachments.exists?  %>
    <% end %>
    <% if !product.discount.blank? %>
     <div class="ribbon"><span>-<%= number_to_percentage(product.discount_percent(product.price, product.discount), precision: 0) %></span></div>
     <% end %>
      <div class="button-row">
        <div class="col-md-6 sharp pull-right">
          <%= button_to "Add to cart", line_items_path(product_id: product), remote: true, class: "btn btn-primary btn-lg sharp" %>
        </div>
        <div class="col-md-6 sharp pull-left">
          <%= link_to "More info", product_path(product), class: "btn btn-primary btn-lg sharp" %>
        </div>
      </div>
    <div class"col-md-12">
      <p class="text-center title"><%= link_to product.title, product_path(product) %></p>
    </div>
    <div class="col-md-12">
      <% if !product.discount.blank? %>
        <h3 class="price text-center" <% if !product.discount.blank? %> style="text-decoration: line-through;" <% end %> >€<%= product.price %> </h3>
        <hr class="hr-price">
        <h3 class="price text-center">€<%= product.price - product.discount %></h3>
        <% else %>
          <h3 class="price text-center" style="padding-bottom: 24px;">€<%= product.price %></h3>
      <% end %>
    </div>
  </div>
  <div class="col-md-12">
    <% if !product.product_attributes.empty? %>
      <div class="row">
      <table class="table table-hover table-responsive">
        <tbody>
          <% product.product_attributes.first(6).each do |attribute| %>
            <tr>
              <th scope="row"><%= attribute.title %></th>
              <td class="over-flow"><%= attribute.details %></td>
            </tr>
            <% end %>
        </tbody>
      </table>
      </div>
    <% end %>
  </div>
</div>

app/views/products/index.html.erb
<%= stylesheet_link_tag "navbar", "products", "home_page", "footer" %>
<% @title="Flybit - #{@current_category}" %>

<!-- left side navbar -->
<div class="container" id="content">
	<div class="row">
    <!-- normal collapsible navbar markup -->
    <div class="center-block">
    <h3><%= @current_category %></h3>
    <h4>Search in this category</h4>
    <%= form_tag products_path, method: 'get' do %>
			<%= text_field_tag :search %>
			<%= hidden_field_tag(:selected, params[:selected]) %>
			<%= submit_tag "Search" %>
		<% end %>
	</div>
  </div>
  <div class="row">
  
		<div class="row">
			<div class="col-md-4 col-xs-4">
			</div>
			<div class="col-md-4 col-xs-4">
				<%= will_paginate if !@products.blank? %> 
			</div>
			<div class="col-md-4 col-xs-4">
			</div>
		</div>
    <!-- your page content -->
		<% if @products.blank? %>
		  <h4>No products found in this category</h4>
		  		<h4><%= link_to "Show all products", products_path(selected: params[:selected]) %></h4>
				<% else %>
					<% if params[:search].present? %>
						<h4>Found <%= pluralize(@products.count, 'product') %> in this category</h4>
						<h4><%= link_to "Back", products_path(selected: params[:selected]) %></h4>
					<% end %>
			<div class="row">
		  	<%= render @products %>
		 	</div>
		<% end %>
	</div>
</div>

<div class="row">
	<div class="col-md-4 col-xs-4">
	</div>
	<div class="col-md-4 col-xs-4">
		<%= will_paginate if !@products.blank? %> 
	</div>
	<div class="col-md-4 col-xs-4">
	</div>
</div>

app/views/products/new.html.erb
<%= stylesheet_link_tag "navbar" %>
<%= form_for @product, method: :post do |f|  %>
  <div class="field">
    <%= f.file_field :image %>
  </div>
  <div class="actions">
    <%= f.submit "Add More Images" %>
  </div>
<% end %>

app/views/products/product_search.html.erb
<%= stylesheet_link_tag "navbar", "footer" %>

<div class="row">
  <div class="center-block" style="width:50%">
  	<%= will_paginate if !@products.blank? %>
  </div>
</div>

<div class="row">
	<div class="col-md-1"></div>
	<div class="col-md-10">
		<% if @products.blank? %>
		  <h4>There are no products containing the term "<%= params[:search] %>"</h4>
		  <div style="width: 10%">
		  	<%= link_to "Browse shop", departments_path, class: "btn btn-primary btn-sm btn-block" %>
		  </div>
		<% else %>
			<h4>Found <%= @products.count %> products</h4>

	  	<div class="row">
	  		<%= render @products %>
	  	</div>
		<% end %>
	</div>
	<div class="col-md-1"></div>
</div>

<div class="row">
  <div class="center-block" style="width:50%">
  	<%= will_paginate if !@products.blank? %>
  </div>
</div>

app/views/products/show.html.erb
<% @title="Flybit - #{@product.title}" %>
<%= stylesheet_link_tag "navbar", "product_show_page", "chocolat", "footer" %>
<%= javascript_include_tag "jquery.chocolat" %>
<div class="container">

  <h2><%= @product.title %></h2>

	<div class="row">
		<div class="col-md-8 col-sm-8">
		  <div class="chocolat-parent" data-chocolat-title="set title">
		    <a class="chocolat-image" href="<%= asset_path(@product.attachments.first.image.url) %>" title="<%= @product.title %>">
		        <%= cl_image_tag @product.attachments.first.image, :width => 500, :crop=>"pad" %>
		    <% if !@product.discount.blank? %>
		     	<div class="ribbon"><span>-<%= number_to_percentage(@product.discount_percent(@product.price, @product.discount), precision: 0) %></span></div>
		     <% end %>
		    </a>
				<div class="row">
					<% if !@product.attachments.order("id").drop(1).empty? %>
						<hr>
						<% @product.attachments.order("id").drop(1).each do |attachment| %>
					    <a class="chocolat-image img-thumbnail" href="<%= attachment.image %>" title="<%= @product.title %>">
					        <%= cl_image_tag attachment.image, :width => 50, :crop=>"pad" %>
					    </a>
				    <% end %>
			    <% end %>
				  <hr>
				</div>
			</div>
		</div>
			<div class="col-md-4 col-sm-4">
				<div class="row">
					<div class="col-md-6 col-sm-6">
						<% if !@product.discount.blank? %>
			        <h3 class="price text-center" <% if !@product.discount.blank? %> style="text-decoration: line-through;" <% end %> >€<%= @product.price %> </h3>
			        <hr class="hr-price">
			        <h3 class="price text-center">€<%= @product.price - @product.discount %></h3>
			        <% else %>
			          <h3 class="price text-center" style="padding-bottom: 24px;">€<%= @product.price %></h3>
			      <% end %>
					</div>
					<div class="col-md-6 col-sm-6">
						<%= button_to line_items_path(product_id: @product), remote: true, class: "btn btn-default btn-lg outline" do %>
							<i>Add to cart</i>
						<% end %>
					</div>
				</div>
				<hr>	
				<div class="row description-text">
					<%= @product.description %>
					<hr>
				</div>
			</div>
	</div><!--End of row -->
<% if !@product.product_attributes.empty? %>
	<div class="row">
	<table class="table table-hover table-responsive">
	  <tbody>
	  	<% @product.product_attributes.each do |attribute| %>
		    <tr>
		      <th scope="row"><%= attribute.title %></th>
		      <td><%= attribute.details %></td>
		    </tr>
		    <% end %>
	  </tbody>
	</table>
	</div>
<% end %>

<script>
	$('.chocolat-parent').Chocolat();
</script>




        

    